# StatChangeAttr | pokemon-rogue-battle
Documentation for pokemon-rogue-battle

# Class StatChangeAttr

Base class defining all Move Effect Attributes

#### See

`apply`

#### Hierarchy (view full)

- MoveEffectAttr
  - StatChangeAttr
    - GrowthStatChangeAttr
    - HalfHpStatMaxAttr
    - CutHpStatBoostAttr

- Defined in src/data/move.ts:2211

#####
Index

### Constructors

constructor

### Properties

condition
firstHitOnly
levels
selfTarget
showMessage
stats
trigger

### Methods

apply
canApply
getCondition
getFailedText
getLevels
getTargetBenefitScore
getUserBenefitScore

## Constructors

### constructor

- new StatChangeAttr(stats, levels, selfTarget?, condition?, showMessage?, firstHitOnly?, moveEffectTrigger?): StatChangeAttr

- #### Parameters

  - stats: BattleStat | BattleStat []
  - levels: number
  - `Optional` selfTarget: boolean
  - `Optional` condition: MoveConditionFunc
  - showMessage: boolean = true
  - firstHitOnly: boolean = false
  - moveEffectTrigger: MoveEffectTrigger = MoveEffectTrigger.HIT

  #### Returns StatChangeAttr

  Overrides MoveEffectAttr.constructor

  - Defined in src/data/move.ts:2217

## Properties

### `Private` condition

condition: MoveConditionFunc

- Defined in src/data/move.ts:2214

### firstHitOnly

firstHitOnly: boolean

Should this effect only apply on the first hit?

Inherited from MoveEffectAttr.firstHitOnly

- Defined in src/data/move.ts:795

### levels

levels: number

- Defined in src/data/move.ts:2213

### selfTarget

selfTarget: boolean

Should this `Move` target the user?

Inherited from MoveEffectAttr.selfTarget

- Defined in src/data/move.ts:718

### `Private` showMessage

showMessage: boolean

- Defined in src/data/move.ts:2215

### stats

stats: BattleStat []

- Defined in src/data/move.ts:2212

### trigger

trigger: MoveEffectTrigger

Defines when this effect should trigger in the move's effect order

#### See

MoveEffectPhase.start

Inherited from MoveEffectAttr.trigger

- Defined in src/data/move.ts:793

## Methods

### apply

- apply(user, target, move, args): boolean | Promise<boolean>

- Applies move effects so long as they are able based on `canApply`

  #### Parameters

  - user: default
  - target: default
  - move: default
  - args: any[]

  #### Returns boolean | Promise<boolean>

  Overrides MoveEffectAttr.apply

  - Defined in src/data/move.ts:2227

### canApply

- canApply(user, target, move, args): boolean

- Determines whether the `Move`'s effects are valid to `apply`

  #### Parameters

  - user: default

    `Pokemon` using the move

  - target: default

    `Pokemon` target of the move

  - move: default

    `Move` with this attribute

  - args: any[]

    Set of unique arguments needed by this attribute

  #### Returns boolean

  true if basic application of the ability attribute should be possible

  Inherited from MoveEffectAttr.canApply

  - Defined in src/data/move.ts:812

### getCondition

- getCondition(): MoveCondition | MoveConditionFunc

- #### Returns MoveCondition | MoveConditionFunc

  the `MoveCondition` or MoveConditionFunc for this `Move`

  Inherited from MoveEffectAttr.getCondition

  - Defined in src/data/move.ts:742

### getFailedText

- getFailedText(user, target, move, cancelled): string

- #### Parameters

  - user: default

    `Pokemon` using the move

  - target: default

    `Pokemon` target of the move

  - move: default

    `Move` with this attribute

  - cancelled: BooleanHolder

    `Utils.BooleanHolder` which stores if the move should fail

  #### Returns string

  the string representing failure of this `Move`

  Inherited from MoveEffectAttr.getFailedText

  - Defined in src/data/move.ts:754

### getLevels

- getLevels(_user): number

- #### Parameters

  - _user: default

  #### Returns number

  - Defined in src/data/move.ts:2241

### getTargetBenefitScore

- getTargetBenefitScore(user, target, move): number

- Used by the Enemy AI to rank an attack based on a given target

  #### Parameters

  - user: default
  - target: default
  - move: default

  #### Returns number

  #### See

  `EnemyPokemon.getNextMove`

  Overrides MoveEffectAttr.getTargetBenefitScore

  - Defined in src/data/move.ts:2245

### getUserBenefitScore

- getUserBenefitScore(user, target, move): number

- Used by the Enemy AI to rank an attack based on a given user

  #### Parameters

  - user: default
  - target: default
  - move: default

  #### Returns number

  #### See

  `EnemyPokemon.getNextMove`

  Inherited from MoveEffectAttr.getUserBenefitScore

  - Defined in src/data/move.ts:763